local f1 = CreateFrame("Frame","PlayerStats",UIParent,"TooltipBorderedFrameTemplate")
local f2 = CreateFrame("Frame","CombatStats",UIParent,"TooltipBorderedFrameTemplate")
local f3 = CreateFrame("Frame","QuestStats",UIParent,"TooltipBorderedFrameTemplate")
local f4 = CreateFrame("Frame","TargetBar",UIParent,"TooltipBorderedFrameTemplate")
local f5 = CreateFrame("Frame","ThreatBar",UIParent,"TooltipBorderedFrameTemplate")

local b1 = CreateFrame("Button","TargetMob",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b2 = CreateFrame("Button","TargetPlayer",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local b3 = CreateFrame("Button","pVendor",f4,"TooltipBorderedFrameTemplate")
local b4 = CreateFrame("Button","tStar",f4,"TooltipBorderedFrameTemplate")
local b5 = CreateFrame("Button","tCircle",f4,"TooltipBorderedFrameTemplate")
local b6 = CreateFrame("Button","tDiamond",f4,"TooltipBorderedFrameTemplate")
local b7 = CreateFrame("Button","tTriangle",f4,"TooltipBorderedFrameTemplate")
local b8 = CreateFrame("Button","tMoon",f4,"TooltipBorderedFrameTemplate")
local b9 = CreateFrame("Button","tSquare",f4,"TooltipBorderedFrameTemplate")
local b10 = CreateFrame("Button","tCross",f4,"TooltipBorderedFrameTemplate")
local b11 = CreateFrame("Button","tSkull",f4,"TooltipBorderedFrameTemplate")

local b12 = CreateFrame("Button","tPartyOne",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b13 = CreateFrame("Button","tPartyTwo",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b14 = CreateFrame("Button","tPartyThree",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b15 = CreateFrame("Button","tPartyFour",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b16 = CreateFrame("Button","tRaidFive",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b17 = CreateFrame("Button","tRaidSix",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b18 = CreateFrame("Button","tRaidSeven",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b19 = CreateFrame("Button","tRaidEight",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b20 = CreateFrame("Button","tRaidNine",f4,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local b21 = CreateFrame("Button","pViewPlayer",f4,"TooltipBorderedFrameTemplate")
local b22 = CreateFrame("Button","pViewCombat",f4,"TooltipBorderedFrameTemplate")
local b23 = CreateFrame("Button","pViewQuests",f4,"TooltipBorderedFrameTemplate")
local b24 = CreateFrame("Button","pViewTargets",f4,"TooltipBorderedFrameTemplate")

local t1 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t2 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t3 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t5 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t8 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t9 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")

local t6 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t16 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t17 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t18 = f5:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t10 = b1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t11 = b1:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local t12 = b2:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t13 = b2:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local pMissCount = 0
local pSwingAmount, pSwingCount = 0, 0
local pRangeAmount, pRangeCount = 0, 0
local pSpellAmount, pSpellCount = 0, 0
local pDamageAmount, pDamageCount = 0,0

local pHealAmount, pHealCount = 0, 0
local tHealAmount, tHealCount = 0, 0
local sHealAmount, sHealCount = 0, 0

local pGearAmount, pGearCount = 0, 0
local pGearArea, pStatArea = "Gear", "Stats"
local qText, xText, eText = " ", " ", " "

local function GetPartyStat(statID)
	local p1Health = UnitHealth(statID)
	local p1Mana = UnitPower(statID)
	local p1ManaMax = UnitPowerMax(statID)
	local p1HeathMax = UnitHealthMax(statID)
	local pv1Text = format("%.0f", ((p1Health / p1HeathMax) * 100)) .. "\n" .. format("%.0f", ((p1Mana / p1ManaMax) * 100))
	return pv1Text
end

local function GetPlayerStat(partyID, TitleID, BannerID)
	local pName = UnitName(partyID)
	local pUsedTarget, pUsedRealm = UnitName("playertargettarget")
	local pTargetName = ""
	if(pUsedTarget ~= nil) then pTargetName = "Is targeting " .. pUsedTarget end
	if(pName ~= nil) then
		local pHealth = UnitHealth(partyID)
		local pMana = UnitPower(partyID)
		local pText = pName .. "\n" .. "Power" .. "\n" .. pTargetName
		local pvText = pHealth .. "\n" .. pMana
		TitleID:SetText(pText)
		BannerID:SetText(pvText)
	end
end

local function GetAllTargets()
	local statusParty = ""
	for t=1,4 do
		local pUsedTarget, pUsedRealm = UnitName("party" .. t .. "targettarget")
		local pTargetName = "Party " .. t .. " has no targets."
		if(pUsedTarget ~= nil) then pTargetName = "Party " .. t .. " target is targeting " .. pUsedTarget end
		statusParty = statusParty .. "\n" .. pTargetName
	end
	for t=5,9 do
		local pUsedTarget, pUsedRealm = UnitName("raid" .. t .. "targettarget")
		local pTargetName = "Party " .. t .. " has no targets."
		if(pUsedTarget ~= nil) then pTargetName = "Party " .. t .. " target is targeting " .. pUsedTarget end
		statusParty = statusParty .. "\n" .. pTargetName
	end
	t18:SetText(statusParty)
end

local function UpdatePartyStats()
	local pGroupNum = GetNumGroupMembers()
	GetPlayerStat("player",t10,t11)
	GetPlayerStat("target",t12,t13)
	GetAllTargets()
	if(pGroupNum > 1) then b12:SetText(GetPartyStat("party1")); end
	if(pGroupNum > 2) then b13:SetText(GetPartyStat("party2")); end
	if(pGroupNum > 3) then b14:SetText(GetPartyStat("party3")); end
	if(pGroupNum > 4) then b15:SetText(GetPartyStat("party4")); end
	if(pGroupNum > 5) then b15:SetText(GetPartyStat("raid5")); end
	if(pGroupNum > 6) then b15:SetText(GetPartyStat("raid6")); end
	if(pGroupNum > 7) then b15:SetText(GetPartyStat("raid7")); end
	if(pGroupNum > 8) then b15:SetText(GetPartyStat("raid8")); end
	if(pGroupNum > 9) then b15:SetText(GetPartyStat("raid9")); end
end

local function UpdateClassSpells()
	local _, _, pclassID = UnitClass("player")
	if(UnitAffectingCombat("player") == false) then
		if(pclassID == 2) then
			local pCaster = IsSpellKnown(20217, false)
			if(pCaster == true) then
				b1:SetAttribute("macrotext", "/target player\n/cast Blessing of Kings")
				b12:SetAttribute("macrotext", "/target party1\n/cast Blessing of Kings")
				b13:SetAttribute("macrotext", "/target party2\n/cast Blessing of Kings")
				b14:SetAttribute("macrotext", "/target party3\n/cast Blessing of Kings")
				b15:SetAttribute("macrotext", "/target party4\n/cast Blessing of Kings")
				b16:SetAttribute("macrotext", "/target raid5\n/cast Blessing of Kings")
				b17:SetAttribute("macrotext", "/target raid6\n/cast Blessing of Kings")
				b18:SetAttribute("macrotext", "/target raid7\n/cast Blessing of Kings")
				b19:SetAttribute("macrotext", "/target raid8\n/cast Blessing of Kings")
				b20:SetAttribute("macrotext", "/target raid9\n/cast Blessing of Kings")
			end
			if(pCaster == false) then
				b1:SetAttribute("macrotext", "/target player\n/cast Blessing of Wisdom")
				b12:SetAttribute("macrotext", "/target party1\n/cast Blessing of Wisdom")
				b13:SetAttribute("macrotext", "/target party2\n/cast Blessing of Wisdom")
				b14:SetAttribute("macrotext", "/target party3\n/cast Blessing of Wisdom")
				b15:SetAttribute("macrotext", "/target party4\n/cast Blessing of Wisdom")
				b16:SetAttribute("macrotext", "/target raid5\n/cast Blessing of Wisdom")
				b17:SetAttribute("macrotext", "/target raid6\n/cast Blessing of Wisdom")
				b18:SetAttribute("macrotext", "/target raid7\n/cast Blessing of Wisdom")
				b19:SetAttribute("macrotext", "/target raid8\n/cast Blessing of Wisdom")
				b20:SetAttribute("macrotext", "/target raid9\n/cast Blessing of Wisdom")
			end
		end
		if(pclassID == 5) then
			b1:SetAttribute("macrotext", "/target player\n/cast Power Word: Fortitude")
			b12:SetAttribute("macrotext", "/target party1\n/cast Power Word: Fortitude")
			b13:SetAttribute("macrotext", "/target party2\n/cast Power Word: Fortitude")
			b14:SetAttribute("macrotext", "/target party3\n/cast Power Word: Fortitude")
			b15:SetAttribute("macrotext", "/target party4\n/cast Power Word: Fortitude")
			b16:SetAttribute("macrotext", "/target raid5\n/cast Power Word: Fortitude")
			b17:SetAttribute("macrotext", "/target raid6\n/cast Power Word: Fortitude")
			b18:SetAttribute("macrotext", "/target raid7\n/cast Power Word: Fortitude")
			b19:SetAttribute("macrotext", "/target raid8\n/cast Power Word: Fortitude")
			b20:SetAttribute("macrotext", "/target raid9\n/cast Power Word: Fortitude")
		end
		if(pclassID == 8) then
			b1:SetAttribute("macrotext", "/target player\n/cast Arcane Intellect")
			b12:SetAttribute("macrotext", "/target party1\n/cast Arcane Intellect")
			b13:SetAttribute("macrotext", "/target party2\n/cast Arcane Intellect")
			b14:SetAttribute("macrotext", "/target party3\n/cast Arcane Intellect")
			b15:SetAttribute("macrotext", "/target party4\n/cast Arcane Intellect")
			b16:SetAttribute("macrotext", "/target raid5\n/cast Arcane Intellect")
			b17:SetAttribute("macrotext", "/target raid6\n/cast Arcane Intellect")
			b18:SetAttribute("macrotext", "/target raid7\n/cast Arcane Intellect")
			b19:SetAttribute("macrotext", "/target raid8\n/cast Arcane Intellect")
			b20:SetAttribute("macrotext", "/target raid9\n/cast Arcane Intellect")
		end
		if(pclassID == 11) then
			b1:SetAttribute("macrotext", "/target player\n/cast Mark of the Wild")
			b12:SetAttribute("macrotext", "/target party1\n/cast Mark of the Wild")
			b13:SetAttribute("macrotext", "/target party2\n/cast Mark of the Wild")
			b14:SetAttribute("macrotext", "/target party3\n/cast Mark of the Wild")
			b15:SetAttribute("macrotext", "/target party4\n/cast Mark of the Wild")
			b16:SetAttribute("macrotext", "/target raid5\n/cast Mark of the Wild")
			b17:SetAttribute("macrotext", "/target raid6\n/cast Mark of the Wild")
			b18:SetAttribute("macrotext", "/target raid7\n/cast Mark of the Wild")
			b19:SetAttribute("macrotext", "/target raid8\n/cast Mark of the Wild")
			b20:SetAttribute("macrotext", "/target raid9\n/cast Mark of the Wild")
		end
	end
end

local function VendorGray()
	local i,j,xSold = 0,0,0
	repeat
		local gSlots = GetContainerNumSlots(i)
		if(gSlots ~= nil) then
			j = 1
			repeat
				local gItemLink = GetContainerItemLink(i, j)
				if(gItemLink ~= nil) then
					local _,_,gQuality = GetItemInfo(gItemLink)
					if(gQuality ~= nil) then
						if(gQuality == 0) then UseContainerItem(i,j) ; xSold = xSold + 1 end
					end
				end
				j = j + 1
			until(j > gSlots)
		end
		i = i + 1
	until(i > 4)
	DEFAULT_CHAT_FRAME:AddMessage("Sold " .. xSold .. " gray items.")
end

local function SendStatus(self, ...)
	local playerUsed = UnitGUID("player")
	local targetUsed = UnitGUID("target")
	local _, peventtype, _, psourceGUID, _, _, _, pdestGUID, _, _, _ = ...
	if(psourceGUID == playerUsed) then
		if(peventtype == "SWING_DAMAGE") then
			local pamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSwingCount = pSwingCount + 1 ; pSwingAmount = pSwingAmount + pamount
		end
		if(peventtype == "SPELL_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + pspellamount
		end
		if(peventtype == "SPELL_PERIODIC_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + pspellamount
		end
		if(peventtype == "RANGE_DAMAGE") then
			local _, _, _, prangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pRangeCount = pRangeCount + 1 ; pRangeAmount = pRangeAmount + prangeamount
		end

		if(peventtype == "SWING_MISSED") then pMissCount = pMissCount + 1 end
		if(peventtype == "SPELL_MISSED") then pMissCount = pMissCount + 1 end
		if(peventtype == "RANGE_MISSED") then pMissCount = pMissCount + 1 end

		if(pdestGUID == playerUsed) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + pspellamount
			end
		end
		if(pdestGUID ~= playerUsed) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + pspellamount
			end
		end
	end
	if(psourceGUID ~= playerUsed) then
		if(pdestGUID == playerUsed) then
			if(peventtype == "SWING_DAMAGE") then
				local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + amount
			end
			if(peventtype == "SPELL_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(peventtype == "RANGE_DAMAGE") then
				local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + rangeamount
			end

			if(peventtype == "SWING_MISSED") then pDamageCount = pDamageCount + 1 end
			if(peventtype == "SPELL_MISSED") then pDamageCount = pDamageCount + 1 end
			if(peventtype == "RANGE_MISSED") then pDamageCount = pDamageCount + 1 end

			if(peventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
		end
	end
end

local function UpdateGearView(gearName, gearLevel)
	local gearStat = 0
	if(gearLevel == nil) then gearStat = 0 end
	if(gearLevel ~= nil) then gearStat = gearLevel end
	pGearArea = pGearArea .. "\n" .. gearName
	pStatArea = pStatArea .. "\n" .. gearStat
	pGearCount = pGearCount + 1
	pGearAmount = pGearAmount + gearStat
end

local function UpdateSlotGear(gearUpdate)
	local pitemLink = GetInventoryItemLink("player", GetInventorySlotInfo(gearUpdate))
	if(pitemLink ~= nil) then local wName, _, _, wLvl = GetItemInfo(pitemLink) ; UpdateGearView(wName, wLvl) end
end

local function UpdateGear()
	pGearCount, pGearAmount = 0, 0
	pGearArea, pStatArea = " ", " "
	UpdateSlotGear("MainHandSlot")
	UpdateSlotGear("SecondaryHandSlot")
	UpdateSlotGear("HeadSlot")
	UpdateSlotGear("NeckSlot")
	UpdateSlotGear("ShoulderSlot")
	UpdateSlotGear("BackSlot")
	UpdateSlotGear("ChestSlot")
	UpdateSlotGear("WristSlot")
	UpdateSlotGear("HandsSlot")
	UpdateSlotGear("WaistSlot")
	UpdateSlotGear("LegsSlot")
	UpdateSlotGear("FeetSlot")
	UpdateSlotGear("Finger0Slot")
	UpdateSlotGear("Finger1Slot")
	UpdateSlotGear("Trinket0Slot")
	UpdateSlotGear("Trinket1Slot")
	pGearArea = pGearArea .. "\n" .. "Equipped"
	if(pGearCount > 0) then pStatArea = pStatArea .. "\n" .. format("%.0f", (pGearAmount / pGearCount)) end
end

local function UpdateStats()
	local pCrit = format("%.2f%%", GetCritChance())
	local sCrit = format("%.2f%%", GetSpellCritChance())
	local rCrit = format("%.2f%%", GetRangedCritChance())
	local pHit, base = GetManaRegen()
	local cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	local bPwr, pPwr, nPwr = UnitAttackPower("player")
	local rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	local ePwr = bPwr + pPwr + nPwr
	local rePwr = rbPwr + rpPwr + rnPwr
	local saText = "Attack\nRanged\n\nMelee Crit\nSpell Crit\nRanged Crit\n\nMana Regen\nCombat Regen\nMove Speed\n" .. pGearArea
	local sbText = ePwr .. "\n" .. rePwr .. "\n\n" .. pCrit .. "\n" .. sCrit .. "\n" .. rCrit .. "\n\n" .. format("%.2f", (base * 2)) .. "\n" .. format("%.2f", (pHit * 2)) .. "\n" .. format("%.0f", cSpeed) .. "\n" .. pStatArea
	t1:SetText(saText) ; t2:SetText(sbText)
end

local function UpdateCombat()	
	local pTotalAvg, pSwingAvg, pRangeAvg, pSpellAvg = 0, 0, 0, 0
	local pDamageAvg, pHealAvg, tHealAvg, sHealAvg, pHealTotalAvg = 0, 0, 0, 0, 0

	local pTotalAmount = pSpellAmount + pSwingAmount + pRangeAmount
	local pTotalCount = pSpellCount + pSwingCount + pRangeCount + pMissCount

	local pHealTotalAmount = pHealAmount + tHealAmount + sHealAmount
	local pHealTotalCount = pHealCount + tHealCount + sHealCount
	
	local vText = " \nMissed\nSwing\nSpell\nRange\nAttacks\n\nHealed\nHealing\nHealers\nHeals\n\nDamage"
	local lText = format("%8s", "Hits")
	local kText = format("%8s", "Avg")
	local gText = format("%8s", "Total")
	
	if(pSwingCount > 0) then pSwingAvg = (pSwingAmount / pSwingCount); end
	if(pRangeCount > 0) then pRangeAvg = (pRangeAmount / pRangeCount); end
	if(pSpellCount > 0) then pSpellAvg = (pSpellAmount / pSpellCount); end
	if(pTotalCount > 0) then pTotalAvg = (pTotalAmount / pTotalCount); end

	if(pHealCount > 0) then pHealAvg = (pHealAmount / pHealCount); end
	if(tHealCount > 0) then tHealAvg = (tHealAmount / tHealCount); end
	if(sHealCount > 0) then sHealAvg = (sHealAmount / sHealCount); end
	if(pHealTotalCount > 0) then pHealTotalAvg = (pHealTotalAmount / pHealTotalCount); end

	if(pDamageCount > 0) then pDamageAvg = pDamageAmount / pDamageCount end

	lText = lText .. "\n" .. format("%8d", pMissCount)
	lText = lText .. "\n" .. format("%8d", pSwingCount)
	lText = lText .. "\n" .. format("%8d", pSpellCount)
	lText = lText .. "\n" .. format("%8d", pRangeCount)
	lText = lText .. "\n" .. format("%8d", pTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pHealCount)
	lText = lText .. "\n" .. format("%8d", tHealCount)
	lText = lText .. "\n" .. format("%8d", sHealCount)
	lText = lText .. "\n" .. format("%8d", pHealTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pDamageCount)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pSwingAvg)
	kText = kText .. "\n" .. format("%8d", pSpellAvg)
	kText = kText .. "\n" .. format("%8d", pRangeAvg)
	kText = kText .. "\n" .. format("%8d", pTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pHealAvg)
	kText = kText .. "\n" .. format("%8d", tHealAvg)
	kText = kText .. "\n" .. format("%8d", sHealAvg)
	kText = kText .. "\n" .. format("%8d", pHealTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pDamageAvg)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pSwingAmount)
	gText = gText .. "\n" .. format("%10d", pSpellAmount)
	gText = gText .. "\n" .. format("%10d", pRangeAmount)
	gText = gText .. "\n" .. format("%10d", pTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pHealAmount)
	gText = gText .. "\n" .. format("%10d", tHealAmount)
	gText = gText .. "\n" .. format("%10d", sHealAmount)
	gText = gText .. "\n" .. format("%10d", pHealTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pDamageAmount)

	t3:SetText(vText)
	t5:SetText(lText)
	t8:SetText(kText)
	t9:SetText(gText)
end

local function UpdateZoneText(tZone, lZone, MZone)
	qText = qText .. "\n" .. tZone
	xText = xText .. "\n" .. lZone
	eText = eText .. "\n" .. MZone
end

local function UpdateExperience()
	local pLvl = UnitLevel("player")
	local pExp = UnitXP("player")
	local pExpMax = UnitXPMax("player")
	local tExp = pExpMax - pExp
	local pXPLvl = ((pLvl * 5) + 45)
	local tExpCount = tExp / pXPLvl
	qText, xText, eText = "", "", ""
	UpdateZoneText("NPC Level " .. pLvl .. " (" .. pXPLvl .. " xp)","-",format("%.0f", tExpCount))
	UpdateZoneText("Experience","-",tExp)
	UpdateZoneText("\n","\n","\n")
end

local function UpdateZone()
	local pLvl = UnitLevel("player")
	UpdateZoneText("Zone","Lvl","Max")
	UpdateZoneText("\n","\n","\n")
	if(pLvl < 10) then 
		UpdateZoneText("Dun Morogh","1","10")
		UpdateZoneText("Durotar","1","10")
		UpdateZoneText("Elwynn Forest","1","10")
		UpdateZoneText("Mulgore","1","10")
		UpdateZoneText("Teldrassil","1","10")
		UpdateZoneText("Tirisfal Glades","1","10")
	end
	if(pLvl > 9) then
		if(pLvl < 21) then
			UpdateZoneText("Darkshore","10","20")
			UpdateZoneText("Loch Modan","10","20")
			UpdateZoneText("Silverpine Forest","10","20")
			UpdateZoneText("Westfall","10","20")
		end
	end
	if(pLvl > 14) then
		if(pLvl < 26) then UpdateZoneText("Redridge Mountains","15","25") end
		if(pLvl < 28) then UpdateZoneText("Stonetalon Mountains","15","27") end
	end

	if(pLvl > 17) then
		if(pLvl < 31) then UpdateZoneText("Ashenvale","18","30") end
		if(pLvl < 31) then UpdateZoneText("Duskwood","18","30") end
	end

	if(pLvl > 19) then
		if(pLvl < 31) then UpdateZoneText("Hillsbrad Foothills","20","30") end
		if(pLvl < 31) then UpdateZoneText("Wetlands","20","30") end
	end

	if(pLvl > 24) then
		if(pLvl < 36) then UpdateZoneText("Thousand Needles","25","35") end
	end

	if(pLvl > 29) then
		if(pLvl < 46) then UpdateZoneText("Stranglethorn Vale","30","45") end
	end

	if(pLvl > 34) then
		if(pLvl < 46) then UpdateZoneText("Duskwallow Marsh","35","45") end
		if(pLvl < 46) then UpdateZoneText("Badlands","35","45") end 
		if(pLvl < 46) then UpdateZoneText("Swamp of Sorrows","35","45") end 
	end

	if(pLvl > 29) then
		if(pLvl < 41) then UpdateZoneText("Alterac Mountains","30","40") end
		if(pLvl < 41) then UpdateZoneText("Arathi Highlands","30","40") end
		if(pLvl < 41) then UpdateZoneText("Desolace","30","40") end
	end

	if(pLvl > 39) then
		if(pLvl < 51) then UpdateZoneText("Feralas","40","50") end 
		if(pLvl < 51) then UpdateZoneText("Hinterlands","40","50") end
		if(pLvl < 51) then UpdateZoneText("Tanaris","40","50") end
	end

	if(pLvl > 44) then 
		if(pLvl < 51) then UpdateZoneText("Searing Gorge","45","50") end
		if(pLvl < 56) then UpdateZoneText("Azshara","45","55") end
		if(pLvl < 56) then UpdateZoneText("Blasted Lands","45","55") end
	end

	if(pLvl > 47) then 
		if(pLvl < 56) then UpdateZoneText("Un'goro Crater","48","55") end
		if(pLvl < 56) then UpdateZoneText("Felwood","48","55") end
	end

	if(pLvl > 49) then 
		if(pLvl < 59) then UpdateZoneText("Burning Steppes","50","58") end
	end

	if(pLvl > 50) then 
		if(pLvl < 59) then UpdateZoneText("Western Plaguelands","51","58") end
	end

	if(pLvl > 52) then
		if(pLvl < 61) then UpdateZoneText("Eastern Plaguelands","53","60") end
		if(pLvl < 61) then UpdateZoneText("Winterspring","53","60") end
	end

	if(pLvl > 58) then
		if(pLvl < 61) then UpdateZoneText("Deadwind Pass","59","60") end
		if(pLvl < 61) then UpdateZoneText("Moonglade","59","60") end
		if(pLvl < 61) then UpdateZoneText("Silithus","59","60") end
	end
	UpdateZoneText("\n","\n","\n")
end

local function UpdateDungeon()
	local dLvl = UnitLevel("player")
	UpdateZoneText("Dungeon","Lvl","Boss")
	UpdateZoneText("\n","\n","\n")
	if(dLvl > 12) then
		if(dLvl < 19) then UpdateZoneText("RFC Ragefire Chasm","13","16") end
	end

	if(dLvl > 16) then
		if(dLvl < 24) then UpdateZoneText("VC The Deadmines VC","17","21") end
        	if(dLvl < 25) then UpdateZoneText("WC Wailing Caverns WC","18","22") end
        	if(dLvl < 29) then UpdateZoneText("SFK Shadowfang Keep SFK","18","26") end
	end

	if(dLvl > 19) then
		if(dLvl < 31) then UpdateZoneText("BFD Blackfathom Deeps BFD","22","28") end
	end
    
	if(dLvl > 20) then
		if(dLvl < 32) then UpdateZoneText("STOCKS The Stockade","21","29") end
	end

	if(dLvl > 21) then
        	if(dLvl < 37) then UpdateZoneText("GNOMER Gnomeregan","22","34") end
	end
    
	if(dLvl > 22) then
		if(dLvl < 36) then UpdateZoneText("RFK Razorfen Kraul","25","33") end
	end
    
	if(dLvl > 28) then
		if(dLvl < 37) then UpdateZoneText("SMGY Scarlet Monastery Graveyard","30","34") end
	end

	if(dLvl > 31) then
        	if(dLvl < 40) then UpdateZoneText("SMLIB Scarlet Monastery Library","34","37") end
	end

	if(dLvl > 33) then
		if(dLvl < 44) then UpdateZoneText("RFD Razorfen Down","35","41") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 43) then UpdateZoneText("SMARMS Scarlet Monastery Armory","36","39") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 45) then UpdateZoneText("SMCATH Scarlet Monastery Cathedral","37","42") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 50) then UpdateZoneText("ULDA Uldaman","37","47") end
	end
    
	if(dLvl > 40) then
		if(dLvl < 51) then UpdateZoneText("ZF Zul'Farrak","43","48") end
	end
    
	if(dLvl > 40) then
		if(dLvl < 53) then UpdateZoneText("MARA Maraudon","43","51") end
	end
    
	if(dLvl > 44) then
		if(dLvl < 58) then UpdateZoneText("ST Temple of Atal'Hakkar","47","55") end
	end
    
	if(dLvl > 45) then
		if(dLvl < 61) then UpdateZoneText("BRD Blackrock Depths","48","59") end
	end
    
	if(dLvl > 51) then 
		if(dLvl < 61) then UpdateZoneText("LBRS Lower Blackrock Spire","54","60") end
	end
    
	if(dLvl > 51) then 
		if(dLvl < 61) then UpdateZoneText("DM Dire maul","55","41") end
		if(dLvl < 61) then UpdateZoneText("UBRS Upper Blackrock Spire Raid 10","55","62") end
	end
    
	if(dLvl > 52) then 
		if(dLvl < 61) then UpdateZoneText("STRAT Stratholme","56","62") end
	end

	if(dLvl > 53) then 
		if(dLvl < 61) then UpdateZoneText("SCHOLO Scholomance","57","62") end
	end
	UpdateZoneText("\n","\n","\n")
end

local function UpdateQuestInfo()
	local tGold = 0
	local nEntries, nQuests = GetNumQuestLogEntries()
	UpdateZoneText("Quests","Gold","Level")
	UpdateZoneText("\n","\n","\n")
	for i=1, nEntries do
		local qTitle, qLevel, _, qHeader, _, _, _, qID, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
		if(qHeader == false) then
			local qMoney = GetQuestLogRewardMoney(qID)
			UpdateZoneText(qTitle,GetCoinTextureString(qMoney, 8),qLevel)
			tGold = tGold + qMoney
		end
	end
	UpdateZoneText("\n","\n","\n")
	UpdateZoneText("Total Gold",GetCoinTextureString(tGold, 8),"-")
end

local function GetRaidIcons()
	for i=1,8 do
		if(i == 1) then local w1 = b4:CreateTexture(nil,"OVERLAY") ; w1:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_1") ; w1:SetPoint("CENTER") ; w1:SetSize(32,32) ; end
		if(i == 2) then local w2 = b5:CreateTexture(nil,"OVERLAY") ; w2:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_2") ; w2:SetPoint("CENTER") ; w2:SetSize(32,32) ; end
		if(i == 3) then local w3 = b6:CreateTexture(nil,"OVERLAY") ; w3:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_3") ; w3:SetPoint("CENTER") ; w3:SetSize(32,32) ; end
		if(i == 4) then local w4 = b7:CreateTexture(nil,"OVERLAY") ; w4:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_4") ; w4:SetPoint("CENTER") ; w4:SetSize(32,32) ; end
		if(i == 5) then local w5 = b8:CreateTexture(nil,"OVERLAY") ; w5:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_5") ; w5:SetPoint("CENTER") ; w5:SetSize(32,32) ; end
		if(i == 6) then local w6 = b9:CreateTexture(nil,"OVERLAY") ; w6:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_6") ; w6:SetPoint("CENTER") ; w6:SetSize(32,32) ; end
		if(i == 7) then local w7 = b10:CreateTexture(nil,"OVERLAY") ; w7:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_7") ; w7:SetPoint("CENTER") ; w7:SetSize(32,32) ; end
		if(i == 8) then local w8 = b11:CreateTexture(nil,"OVERLAY") ; w8:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_8") ; w8:SetPoint("CENTER") ; w8:SetSize(32,32) ; end
	end
end

local function ShowStats()
	UpdatePartyStats()
	UpdateCombat()
end

local function ShowGear()
	UpdateGear()
	UpdateStats()
end

local function ShowQuesting()
	UpdateExperience()
	UpdateZone()
	UpdateDungeon()
	UpdateQuestInfo()
	t6:SetText(qText)
	t16:SetText(xText)
	t17:SetText(eText)
end

local function ResetAllAreas()
    	pMissCount = 0
    	pSwingAmount, pSwingCount = 0, 0
    	pRangeAmount, pRangeCount = 0, 0
    	pSpellAmount, pSpellCount = 0, 0
    	pDamageAmount, pDamageCount = 0,0

    	pHealAmount, pHealCount = 0, 0
    	tHealAmount, tHealCount = 0, 0
    	sHealAmount, sHealCount = 0, 0

    	pGearAmount, pGearCount = 0, 0
    	pGearArea, pStatArea = "Gear", "Stats"
	qText, xText, eText = "", "", ""

    	if(MerchantFrame:IsVisible() == false) then b3:Hide() end
	ShowStats(); f2:Show()
    	ShowGear() ; f1:Show()
    	ShowQuesting() ; f3:Show()
	f5:Show()
end

b1:EnableMouse(true)
b1:SetMovable(true)
b1:SetClampedToScreen(true)
b1:RegisterForClicks("AnyUp")
b1:RegisterForDrag("RightButton")
b1:SetScript("OnDragStart", b1.StartMoving)
b1:SetScript("OnDragStop", b1.StopMovingOrSizing)
b1:SetAttribute("type1", "target")
b1:SetAttribute("shift-type1", "macro")
b1:SetAttribute("unit","player")
b1:SetPoint("TOPLEFT",10,20)
b1:SetSize(320, 80)

t10:SetPoint("TOPLEFT",10, -10)
t10:SetWidth(300)
t10:SetHeight(60)
t10:SetJustifyH("LEFT")
t10:SetTextColor(1,0,0,1)

t11:SetPoint("TOPLEFT",10, -10)
t11:SetWidth(300)
t11:SetHeight(60)
t11:SetJustifyH("RIGHT")
t11:SetTextColor(1,0.5,0.5,1)

b2:EnableMouse(true)
b2:SetMovable(true)
b2:SetClampedToScreen(true)
b2:RegisterForDrag("RightButton")
b2:SetScript("OnDragStart", b2.StartMoving)
b2:SetScript("OnDragStop", b2.StopMovingOrSizing)
b2:RegisterForClicks("AnyUp")
b2:SetAttribute("type", "macro")
b2:SetAttribute("macrotext", "/cleartarget\n/stopcasting\n/stopattack\n/targetenemy [noexists][dead]\n/startattack")
b2:SetPoint("TOPLEFT",340,20)
b2:SetSize(320, 80)

t12:SetPoint("TOPLEFT",10, -10)
t12:SetWidth(300)
t12:SetHeight(60)
t12:SetJustifyH("LEFT")
t12:SetTextColor(1,0,0,1)

t13:SetPoint("TOPLEFT",10, -10)
t13:SetWidth(300)
t13:SetHeight(60)
t13:SetJustifyH("RIGHT")
t13:SetTextColor(1,0.5,0.5,1)

f1:SetWidth(320)
f1:SetHeight(380)
f1:SetAlpha(.90)
f1:SetPoint("CENTER",-330,0)
f1:SetMovable(true)
f1:EnableMouse(true)
f1:SetClampedToScreen(true)
f1:RegisterForDrag("RightButton")
f1:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f1:RegisterEvent("MERCHANT_SHOW")
f1:RegisterEvent("MERCHANT_CLOSED")
f1:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE")
f1:RegisterEvent("QUEST_DETAIL")
f1:RegisterEvent("UNIT_HEALTH_FREQUENT")
f1:RegisterEvent("UNIT_POWER_FREQUENT")
f1:RegisterEvent("UNIT_TARGET")
f1:RegisterEvent("UNIT_COMBAT")
f1:SetScript("OnDragStart", f1.StartMoving)
f1:SetScript("OnDragStop", f1.StopMovingOrSizing)
f1:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f1:Hide() end 
end)
f1:SetScript("OnEvent", function(self, event, ...)
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then SendStatus(self, CombatLogGetCurrentEventInfo()) ; ShowStats() end
	if(event == "MERCHANT_SHOW") then b3:Show() end
	if(event == "MERCHANT_CLOSED") then b3:Hide() end
	if(event == "QUEST_DETAIL") then AcceptQuest() end
	if(event == "UNIT_HEALTH_FREQUENT") then ShowStats() end
	if(event == "UNIT_POWER_FREQUENT") then ShowStats() end
	if(event == "UNIT_TARGET") then ShowStats() end
	if(event == "PLAYER_AVG_ITEM_LEVEL_UPDATE") then ShowGear() end
end)

t1:SetPoint("TOPLEFT", 10, -10)
t1:SetWidth(300)
t1:SetHeight(360)
t1:SetJustifyH("LEFT")

t2:SetPoint("TOPLEFT", 10, -10)
t2:SetWidth(300)
t2:SetHeight(360)
t2:SetJustifyH("RIGHT")

f2:SetWidth(420)
f2:SetHeight(260)
f2:SetAlpha(.90)
f2:SetPoint("CENTER", 0, 0)
f2:SetMovable(true)
f2:EnableMouse(true)
f2:SetClampedToScreen(true)
f2:RegisterForDrag("RightButton")
f2:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then f2:Hide() end
end)
f2:SetScript("OnDragStart", f2.StartMoving)
f2:SetScript("OnDragStop", f2.StopMovingOrSizing)

t3:SetPoint("TOPLEFT",10, -10)
t3:SetWidth(70)
t3:SetHeight(240)
t3:SetJustifyH("RIGHT")

t5:SetPoint("TOPLEFT", 90, -10)
t5:SetWidth(90)
t5:SetHeight(240)
t5:SetJustifyH("RIGHT")

t8:SetPoint("TOPLEFT", 190, -10)
t8:SetWidth(90)
t8:SetHeight(240)
t8:SetJustifyH("RIGHT")

t9:SetPoint("TOPLEFT", 290, -10)
t9:SetWidth(110)
t9:SetHeight(240)
t9:SetJustifyH("RIGHT")

f3:SetWidth(480)
f3:SetHeight(640)
f3:SetAlpha(.90)
f3:SetPoint("CENTER",330,0)
f3:SetMovable(true)
f3:EnableMouse(true)
f3:SetClampedToScreen(true)
f3:RegisterForDrag("RightButton")
f3:SetScript("OnDragStart", f3.StartMoving)
f3:SetScript("OnDragStop", f3.StopMovingOrSizing)
f3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then f3:Hide() end
end)

t6:SetPoint("TOPLEFT", 10, -10)
t6:SetWidth(460)
t6:SetHeight(620)
t6:SetJustifyH("LEFT")

t16:SetPoint("TOPLEFT", 240, -10)
t16:SetWidth(140)
t16:SetHeight(620)
t16:SetJustifyH("RIGHT")

t17:SetPoint("TOPLEFT", 10, -10)
t17:SetWidth(460)
t17:SetHeight(620)
t17:SetJustifyH("RIGHT")

f4:SetWidth(420)
f4:SetHeight(140)
f4:SetAlpha(.90)
f4:SetPoint("CENTER",0,-170)
f4:EnableMouse(true)
f4:SetMovable(true)
f4:SetClampedToScreen(true)
f4:RegisterForDrag("RightButton")
f4:SetScript("OnDragStart", f4.StartMoving)
f4:SetScript("OnDragStop", f4.StopMovingOrSizing)
f4:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ResetAllAreas() end 
end)

b3:SetWidth(40)
b3:SetHeight(40)
b3:SetPoint("TOPLEFT",330,-10)
b3:EnableMouse(true)
b3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then VendorGray(); end
end)
b3:SetText("Vendor\nGray\nItems")
b3:SetNormalFontObject("GameFontNormalTiny")

b4:SetWidth(40)
b4:SetHeight(40)
b4:SetPoint("TOPLEFT",10,-10)
b4:EnableMouse(true)
b4:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 1); end
end)

b5:SetWidth(40)
b5:SetHeight(40)
b5:SetPoint("TOPLEFT",50,-10)
b5:EnableMouse(true)
b5:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 2); end
end)

b6:SetWidth(40)
b6:SetHeight(40)
b6:SetPoint("TOPLEFT",90,-10)
b6:EnableMouse(true)
b6:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 3); end
end)

b7:SetWidth(40)
b7:SetHeight(40)
b7:SetPoint("TOPLEFT",130,-10)
b7:EnableMouse(true)
b7:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 4); end
end)

b8:SetWidth(40)
b8:SetHeight(40)
b8:SetPoint("TOPLEFT",170,-10)
b8:EnableMouse(true)
b8:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 5); end
end)

b9:SetWidth(40)
b9:SetHeight(40)
b9:SetPoint("TOPLEFT",210,-10)
b9:EnableMouse(true)
b9:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 6); end
end)

b10:SetWidth(40)
b10:SetHeight(40)
b10:SetPoint("TOPLEFT",250,-10)
b10:EnableMouse(true)
b10:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 7); end
end)

b11:SetWidth(40)
b11:SetHeight(40)
b11:SetPoint("TOPLEFT",290,-10)
b11:EnableMouse(true)
b11:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 8); end
end)

b12:SetWidth(40)
b12:SetHeight(40)
b12:EnableMouse(true)
b12:RegisterForClicks("AnyUp")
b12:SetAttribute("type1", "target")
b12:SetAttribute("shift-type1", "macro")
b12:SetAttribute("unit","party1")
b12:SetPoint("TOPLEFT",10,-50)
b12:SetText("P2")
b12:SetNormalFontObject("GameFontNormal")

b13:SetWidth(40)
b13:SetHeight(40)
b13:EnableMouse(true)
b13:RegisterForClicks("AnyUp")
b13:SetAttribute("type1", "target")
b13:SetAttribute("shift-type1", "macro")
b13:SetAttribute("unit","party2")
b13:SetPoint("TOPLEFT",50,-50)
b13:SetText("P3")
b13:SetNormalFontObject("GameFontNormal")

b14:SetWidth(40)
b14:SetHeight(40)
b14:EnableMouse(true)
b14:RegisterForClicks("AnyUp")
b14:SetAttribute("type1", "target")
b14:SetAttribute("shift-type1", "macro")
b14:SetAttribute("unit","party3")
b14:SetPoint("TOPLEFT",90,-50)
b14:SetText("P4")
b14:SetNormalFontObject("GameFontNormal")

b15:SetWidth(40)
b15:SetHeight(40)
b15:EnableMouse(true)
b15:RegisterForClicks("AnyUp")
b15:SetAttribute("type1", "target")
b15:SetAttribute("shift-type1", "macro")
b15:SetAttribute("unit","party4")
b15:SetPoint("TOPLEFT",130,-50)
b15:SetText("P5")
b15:SetNormalFontObject("GameFontNormal")

b16:SetWidth(40)
b16:SetHeight(40)
b16:EnableMouse(true)
b16:RegisterForClicks("AnyUp")
b16:SetAttribute("type1", "target")
b16:SetAttribute("shift-type1", "macro")
b16:SetAttribute("unit","raid5")
b16:SetPoint("TOPLEFT",170,-50)
b16:SetText("P6")
b16:SetNormalFontObject("GameFontNormal")

b17:SetWidth(40)
b17:SetHeight(40)
b17:EnableMouse(true)
b17:RegisterForClicks("AnyUp")
b17:SetAttribute("type1", "target")
b17:SetAttribute("shift-type1", "macro")
b17:SetAttribute("unit","raid6")
b17:SetPoint("TOPLEFT",210,-50)
b17:SetText("P7")
b17:SetNormalFontObject("GameFontNormal")

b18:SetWidth(40)
b18:SetHeight(40)
b18:EnableMouse(true)
b18:RegisterForClicks("AnyUp")
b18:SetAttribute("type1", "target")
b18:SetAttribute("shift-type1", "macro")
b18:SetAttribute("unit","raid7")
b18:SetPoint("TOPLEFT",250,-50)
b18:SetText("P8")
b18:SetNormalFontObject("GameFontNormal")

b19:SetWidth(40)
b19:SetHeight(40)
b19:EnableMouse(true)
b19:RegisterForClicks("AnyUp")
b19:SetAttribute("type1", "target")
b19:SetAttribute("shift-type1", "macro")
b19:SetAttribute("unit","raid8")
b19:SetPoint("TOPLEFT",290,-50)
b19:SetText("P9")
b19:SetNormalFontObject("GameFontNormal")

b20:SetWidth(40)
b20:SetHeight(40)
b20:EnableMouse(true)
b20:RegisterForClicks("AnyUp")
b20:SetAttribute("type1", "target")
b20:SetAttribute("shift-type1", "macro")
b20:SetAttribute("unit","raid9")
b20:SetPoint("TOPLEFT",330,-50)
b20:SetText("P10")
b20:SetNormalFontObject("GameFontNormal")

b21:SetWidth(40)
b21:SetHeight(40)
b21:EnableMouse(true)
b21:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowStats() ; f2:Show() end 
end)
b21:SetPoint("TOPLEFT",10,-90)
b21:SetText("A")
b21:SetNormalFontObject("GameFontNormal")

b22:SetWidth(40)
b22:SetHeight(40)
b22:EnableMouse(true)
b22:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowQuesting() ; f3:Show() end 
end)
b22:SetPoint("TOPLEFT",50,-90)
b22:SetText("Q")
b22:SetNormalFontObject("GameFontNormal")

b23:SetWidth(40)
b23:SetHeight(40)
b23:EnableMouse(true)
b23:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); f1:Show() end 
end)
b23:SetPoint("TOPLEFT",90,-90)
b23:SetText("C")
b23:SetNormalFontObject("GameFontNormal")

b24:SetWidth(40)
b24:SetHeight(40)
b24:EnableMouse(true)
b24:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); f5:Show() end 
end)
b24:SetPoint("TOPLEFT",130,-90)
b24:SetText("T")
b24:SetNormalFontObject("GameFontNormal")

f5:SetWidth(420)
f5:SetHeight(150)
f5:SetAlpha(.90)
f5:SetPoint("CENTER", 0, 0)
f5:SetMovable(true)
f5:EnableMouse(true)
f5:SetClampedToScreen(true)
f5:RegisterForDrag("RightButton")
f5:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then f5:Hide() end
end)
f5:SetScript("OnDragStart", f5.StartMoving)
f5:SetScript("OnDragStop", f5.StopMovingOrSizing)

t18:SetPoint("TOPLEFT",5, -5)
t18:SetWidth(400)
t18:SetHeight(140)
t18:SetJustifyH("LEFT")

ShowStats()
ShowGear()
ShowQuesting()
UpdateClassSpells()
GetRaidIcons()

f1:Hide() ; f2:Hide() ; f3:Hide() ; f5:Hide() ;  b3:Hide()
f4:Show()





